﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.DayView;

namespace _138118
{
    class Mycreation:IUIElementCreationFilter
    {
        public class OwnerDataInfo
        {
            private bool draft;

            public bool Draft
            {
                get { return draft; }
                set { draft = value; }
            }
            private bool complete;

            public bool Complete
            {
                get { return complete; }
                set { complete = value; }
            }
            private string toolTip;

            public string ToolTip
            {
                get { return toolTip; }
                set { toolTip = value; }
            }
            private Image icon;

            public Image Icon
            {
                get { return icon; }
                set { icon = value; }
            } 
        }
        public delegate void OnOwnerHeaderCheck(object sender, OwnerHeaderCheckBoxArg e);
        public event OnOwnerHeaderCheck OwnerHeaderCheck;

        Dictionary<Owner, OwnerDataInfo> ownerState = new Dictionary<Owner, OwnerDataInfo>();

        public Dictionary<Owner, OwnerDataInfo> OwnerState
        {
            get { return ownerState; }
            set { ownerState = value; }
        }

        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is OwnerHeaderUIElement)
            {
                OwnerHeaderUIElement owner = parent as OwnerHeaderUIElement;
                if (!ownerState.ContainsKey(owner.Owner))
                    ownerState.Add(owner.Owner, new OwnerDataInfo() { Complete = false, Draft = false });


                CheckBoxUIElement chekComplete = new CheckBoxUIElement(parent);
                
                Point loc = parent.Rect.Location;
                loc.Offset(parent.Rect.Width - 80, 2);
                chekComplete.Rect = new System.Drawing.Rectangle(loc, new Size(80, parent.Rect.Height - 4));
                chekComplete.Text = "Complete";
                chekComplete.CheckState = ownerState[owner.Owner].Complete ? System.Windows.Forms.CheckState.Checked : System.Windows.Forms.CheckState.Unchecked;
                chekComplete.ElementClick += chekComplete_ElementClick;
                parent.ChildElements.Add(chekComplete);

                CheckBoxUIElement chekDraft = new CheckBoxUIElement(parent);

                loc.Offset( - 50, 0);
                chekDraft.Rect = new System.Drawing.Rectangle(loc, new Size(50, parent.Rect.Height - 4));
                chekDraft.Text = "Draft";
                chekDraft.CheckState = ownerState[owner.Owner].Draft ? System.Windows.Forms.CheckState.Checked : System.Windows.Forms.CheckState.Unchecked;
                chekDraft.ElementClick += chekDraft_ElementClick;
                parent.ChildElements.Add(chekDraft);

                loc.Offset( - parent.Rect.Height , 0);
                ImageAndTextUIElementEx img = new ImageAndTextUIElementEx(parent);
                img.Image = ownerState[owner.Owner].Icon;
                img.ScaledImageSize = new Size(parent.Rect.Height - 4, parent.Rect.Height - 4);
                img.ToolTipItem = new MyTooltip(ownerState[owner.Owner].ToolTip);
                img.Rect = new System.Drawing.Rectangle(loc, new Size(parent.Rect.Height - 4, parent.Rect.Height - 4));
                parent.ChildElements.Add(img);


                TextUIElement ownerLabel = parent.GetDescendant(typeof(TextUIElement)) as TextUIElement;
                if (ownerLabel != null)
                {
                    ownerLabel.Rect = new Rectangle(parent.Rect.Location, ownerLabel.Rect.Size);
                }

            }
        }

        void chekDraft_ElementClick(object sender, UIElementEventArgs e)
        {
            CheckBoxUIElement c = (CheckBoxUIElement)e.Element;
            OwnerHeaderUIElement parent = (OwnerHeaderUIElement)e.Element.Parent;

             ownerState[parent.Owner].Draft =  c.CheckState == System.Windows.Forms.CheckState.Checked   ? true : false;
            if (OwnerHeaderCheck != null)
                OwnerHeaderCheck.Invoke(sender, new OwnerHeaderCheckBoxArg(parent.Owner));
        }

        void chekComplete_ElementClick(object sender, UIElementEventArgs e)
        {
            CheckBoxUIElement c = (CheckBoxUIElement)e.Element;
            OwnerHeaderUIElement parent = (OwnerHeaderUIElement)e.Element.Parent;

             ownerState[parent.Owner].Complete =  c.CheckState == System.Windows.Forms.CheckState.Checked   ? true : false;
            if (OwnerHeaderCheck != null)
                OwnerHeaderCheck.Invoke(sender, new OwnerHeaderCheckBoxArg(parent.Owner));
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }

    public class OwnerHeaderCheckBoxArg : EventArgs
    {
        Owner o;
        public Owner Owner
        {
            get { return o; }
        }

        public OwnerHeaderCheckBoxArg(Owner owner)
        {
            this.o = owner;
        }
    }

    public class MyTooltip : IToolTipItem
    {
        private string tooltip;

        public MyTooltip(string tooltip)
        {
            // TODO: Complete member initialization
            this.tooltip = tooltip;
        }
        #region IToolTipItem Members

        public ToolTipInfo GetToolTipInfo(Point mousePosition, UIElement element, UIElement previousToolTipElement, ToolTipInfo toolTipInfoDefault)
        {
            toolTipInfoDefault.ToolTipText = tooltip;
            return toolTipInfoDefault;
            throw new NotImplementedException();
        }

        #endregion
    }


}
